# SSL TCP CHAT CLIENT WITH CHECKERS
# 20190901
#
import socket
import select
import string
import ssl
import traceback
import sys, tty, termios

GAME_DIR='/bbs/dama' 
MAX_INPUT=38
INP_Y=21
INP_X=4  

CHAT_ROWS=12
CLR_BLACK=u"\u001b[30m"
CLR_RED=u"\u001b[31m"
CLR_GREEN=u"\u001b[32m"
CLR_YELLOW=u"\u001b[33m"
CLR_BLUE=u"\u001b[34m"
CLR_MAGENTA=u"\u001b[35m"
CLR_CYAN=u"\u001b[36m"
CLR_WHITE=u"\u001b[37m"
CLR_GREEN="\033[31m;"
CTRL_RESET=u"\u001b[0m"
CTRL_RESET="\033[0m;"

boardWin=None 
chatWin=None 
cmdLineWin=None 
messages=[]
s=None
items=0

def curLineUp(lines):
  ret=""
  for i in range(lines):
    ret+="\033[A"
  return(ret)

def clrReset():
  return("\033[0m")
   
def clrWhite():
  return("\033[1;37m")

def clrBlue():
  return("\033[1;34m")

def clrRed():
  return("\033[1;31m")

def clrBlack():
  return("\033[0;30m")

def curBack(shift):
  return("\033["+str(shift)+"C")

def curForward(shift):
  return("\033["+str(shift)+"D")
 
def curPosition(x,y):
  return("\033["+str(x)+";"+str(y)+"H")

#def printFile(filename):   
#  for line in file:
#    print(line.replace('\x0a',''))

def printBlankField(x,y):
  print(curPosition(x,y))
  print(clrBlack()+"\xdb\xdb\xdb\xdb")
  print(curPosition(x+1,y))
  print(clrBlack()+"\xdb\xdb\xdb\xdb")

def printEmptyBoard(x,y):
  sys.stdout.write(curPosition(x+0,y)) # 81
  sys.stdout.write("\x1b\x5b\x31\x3b\x32\x35\x3b\x33\x30\x3b\x34\x30\x6d\xdb\xdb\xdb\xdb\x1b\x5b\x30\x6d\x20\x20\x20\x20\x1b\x5b\x31\x3b\x33\x30\x6d\xdb\xdb\xdb\xdb\x1b\x5b\x30\x6d\x20\x20\x20\x20\x1b\x5b\x31\x3b\x33\x30\x6d\xdb\xdb\xdb\xdb\x1b\x5b\x30\x6d\x20\x20\x20\x20\x1b\x5b\x31\x3b\x33\x30\x6d\xdb\xdb\xdb\xdb\x1b\x5b\x30\x6d\x1b\x5b\x30\x6d\x20\x20\x20\x20")
  sys.stdout.write(curPosition(x+1,y)) # 82
  sys.stdout.write("\x1b\x5b\x31\x3b\x33\x30\x6d\xdb\xdb\xdb\xdb\x1b\x5b\x30\x6d\x20\x20\x20\x20\x1b\x5b\x31\x3b\x33\x30\x6d\xdb\xdb\xdb\xdb\x1b\x5b\x30\x6d\x20\x20\x20\x20\x1b\x5b\x31\x3b\x33\x30\x6d\xdb\xdb\xdb\xdb\x1b\x5b\x30\x6d\x20\x20\x20\x20\x1b\x5b\x31\x3b\x33\x30\x6d\xdb\xdb\xdb\xdb\x1b\x5b\x30\x6d\x1b\x5b\x30\x6d\x20\x20\x20\x20")
  sys.stdout.write(curPosition(x+2,y))
  sys.stdout.write("\x1b\x5b\x31\x3b\x33\x30\x6d\x20\x20\x20\x20\xdb\xdb\xdb\xdb\x20\x20\x20\x20\xdb\xdb\xdb\xdb\x20\x20\x20\x20\xdb\xdb\xdb\xdb\x20\x20\x20\x20\xdb\xdb\xdb\xdb\x1b\x5b\x30\x6d")
  sys.stdout.write(curPosition(x+3,y))
  sys.stdout.write("\x1b\x5b\x31\x3b\x33\x30\x6d\x20\x20\x20\x20\xdb\xdb\xdb\xdb\x20\x20\x20\x20\xdb\xdb\xdb\xdb\x20\x20\x20\x20\xdb\xdb\xdb\xdb\x20\x20\x20\x20\xdb\xdb\xdb\xdb\x1b\x5b\x30\x6d")
  sys.stdout.write(curPosition(x+4,y))
  sys.stdout.write("\x1b\x5b\x31\x3b\x33\x30\x6d\xdb\xdb\xdb\xdb\x1b\x5b\x30\x6d\x20\x20\x20\x20\x1b\x5b\x31\x3b\x33\x30\x6d\xdb\xdb\xdb\xdb\x1b\x5b\x30\x6d\x20\x20\x20\x20\x1b\x5b\x31\x3b\x33\x30\x6d\xdb\xdb\xdb\xdb\x1b\x5b\x30\x6d\x20\x20\x20\x20\x1b\x5b\x31\x3b\x33\x30\x6d\xdb\xdb\xdb\xdb\x1b\x5b\x30\x6d\x1b\x5b\x30\x6d\x20\x20\x20\x20")
  sys.stdout.write(curPosition(x+5,y))
  sys.stdout.write("\x1b\x5b\x31\x3b\x33\x30\x6d\xdb\xdb\xdb\xdb\x1b\x5b\x30\x6d\x20\x20\x20\x20\x1b\x5b\x31\x3b\x33\x30\x6d\xdb\xdb\xdb\xdb\x1b\x5b\x30\x6d\x20\x20\x20\x20\x1b\x5b\x31\x3b\x33\x30\x6d\xdb\xdb\xdb\xdb\x1b\x5b\x30\x6d\x20\x20\x20\x20\x1b\x5b\x31\x3b\x33\x30\x6d\xdb\xdb\xdb\xdb\x1b\x5b\x30\x6d\x1b\x5b\x30\x6d\x20\x20\x20\x20")
  sys.stdout.write(curPosition(x+6,y))
  sys.stdout.write("\x1b\x5b\x31\x3b\x33\x30\x6d\x20\x20\x20\x20\xdb\xdb\xdb\xdb\x20\x20\x20\x20\xdb\xdb\xdb\xdb\x20\x20\x20\x20\xdb\xdb\xdb\xdb\x20\x20\x20\x20\xdb\xdb\xdb\xdb\x1b\x5b\x30\x6d")
  sys.stdout.write(curPosition(x+7,y))
  sys.stdout.write("\x1b\x5b\x31\x3b\x33\x30\x6d\x20\x20\x20\x20\xdb\xdb\xdb\xdb\x20\x20\x20\x20\xdb\xdb\xdb\xdb\x20\x20\x20\x20\xdb\xdb\xdb\xdb\x20\x20\x20\x20\xdb\xdb\xdb\xdb\x1b\x5b\x30\x6d")
  sys.stdout.write(curPosition(x+8,y))
  sys.stdout.write("\x1b\x5b\x31\x3b\x33\x30\x6d\xdb\xdb\xdb\xdb\x1b\x5b\x30\x6d\x20\x20\x20\x20\x1b\x5b\x31\x3b\x33\x30\x6d\xdb\xdb\xdb\xdb\x1b\x5b\x30\x6d\x20\x20\x20\x20\x1b\x5b\x31\x3b\x33\x30\x6d\xdb\xdb\xdb\xdb\x1b\x5b\x30\x6d\x20\x20\x20\x20\x1b\x5b\x31\x3b\x33\x30\x6d\xdb\xdb\xdb\xdb\x1b\x5b\x30\x6d\x1b\x5b\x30\x6d\x20\x20\x20\x20")
  sys.stdout.write(curPosition(x+9,y))
  sys.stdout.write("\x1b\x5b\x31\x3b\x33\x30\x6d\xdb\xdb\xdb\xdb\x1b\x5b\x30\x6d\x20\x20\x20\x20\x1b\x5b\x31\x3b\x33\x30\x6d\xdb\xdb\xdb\xdb\x1b\x5b\x30\x6d\x20\x20\x20\x20\x1b\x5b\x31\x3b\x33\x30\x6d\xdb\xdb\xdb\xdb\x1b\x5b\x30\x6d\x20\x20\x20\x20\x1b\x5b\x31\x3b\x33\x30\x6d\xdb\xdb\xdb\xdb\x1b\x5b\x30\x6d\x1b\x5b\x30\x6d\x20\x20\x20\x20")
  sys.stdout.write(curPosition(x+10,y))
  sys.stdout.write("\x1b\x5b\x31\x3b\x33\x30\x6d\x20\x20\x20\x20\xdb\xdb\xdb\xdb\x20\x20\x20\x20\xdb\xdb\xdb\xdb\x20\x20\x20\x20\xdb\xdb\xdb\xdb\x20\x20\x20\x20\xdb\xdb\xdb\xdb\x1b\x5b\x30\x6d")
  sys.stdout.write(curPosition(x+11,y))
  sys.stdout.write("\x1b\x5b\x31\x3b\x33\x30\x6d\x20\x20\x20\x20\xdb\xdb\xdb\xdb\x20\x20\x20\x20\xdb\xdb\xdb\xdb\x20\x20\x20\x20\xdb\xdb\xdb\xdb\x20\x20\x20\x20\xdb\xdb\xdb\xdb\x1b\x5b\x30\x6d")
  sys.stdout.write(curPosition(x+12,y))
  sys.stdout.write("\x1b\x5b\x31\x3b\x33\x30\x6d\xdb\xdb\xdb\xdb\x1b\x5b\x30\x6d\x20\x20\x20\x20\x1b\x5b\x31\x3b\x33\x30\x6d\xdb\xdb\xdb\xdb\x1b\x5b\x30\x6d\x20\x20\x20\x20\x1b\x5b\x31\x3b\x33\x30\x6d\xdb\xdb\xdb\xdb\x1b\x5b\x30\x6d\x20\x20\x20\x20\x1b\x5b\x31\x3b\x33\x30\x6d\xdb\xdb\xdb\xdb\x1b\x5b\x30\x6d\x1b\x5b\x30\x6d\x20\x20\x20\x20")
  sys.stdout.write(curPosition(x+13,y))
  sys.stdout.write("\x1b\x5b\x31\x3b\x33\x30\x6d\xdb\xdb\xdb\xdb\x1b\x5b\x30\x6d\x20\x20\x20\x20\x1b\x5b\x31\x3b\x33\x30\x6d\xdb\xdb\xdb\xdb\x1b\x5b\x30\x6d\x20\x20\x20\x20\x1b\x5b\x31\x3b\x33\x30\x6d\xdb\xdb\xdb\xdb\x1b\x5b\x30\x6d\x20\x20\x20\x20\x1b\x5b\x31\x3b\x33\x30\x6d\xdb\xdb\xdb\xdb\x1b\x5b\x30\x6d\x1b\x5b\x30\x6d\x20\x20\x20\x20")
  sys.stdout.write(curPosition(x+14,y))
  sys.stdout.write("\x1b\x5b\x31\x3b\x33\x30\x6d\x20\x20\x20\x20\xdb\xdb\xdb\xdb\x20\x20\x20\x20\xdb\xdb\xdb\xdb\x20\x20\x20\x20\xdb\xdb\xdb\xdb\x20\x20\x20\x20\xdb\xdb\xdb\xdb\x1b\x5b\x30\x6d")
  sys.stdout.write(curPosition(x+15,y))
  sys.stdout.write("\x1b\x5b\x31\x3b\x33\x30\x6d\x20\x20\x20\x20\xdb\xdb\xdb\xdb\x20\x20\x20\x20\xdb\xdb\xdb\xdb\x20\x20\x20\x20\xdb\xdb\xdb\xdb\x20\x20\x20\x20\xdb\xdb\xdb\xdb\x1b\x5b\x30\x6d")

def printRedKing(x,y):
  #stoneKingRed.ans
  sys.stdout.write(curPosition(x+0,y))
  sys.stdout.write("\x1b\x5b\x30\x3b\x32\x35\x3b\x33\x37\x3b\x34\x30\x6d\x20\x1b\x5b\x31\x6d\xdc\x1b\x5b\x33\x31\x6d\xdc\x20\x1b\x5b\x30\x6d")
  sys.stdout.write(curPosition(x+1,y))
  sys.stdout.write("\x20\x1b\x5b\x31\x3b\x33\x31\x6d\xdf\x1b\x5b\x30\x3b\x33\x31\x3b\x34\x30\x6d\xdf\x20\x1b\x5b\x30\x6d"+clrBlack())

def printWhiteKing(x,y):
  #stoneKingWhite.ans
  sys.stdout.write(curPosition(x+0,y))
  sys.stdout.write("\x1b\x5b\x30\x3b\x32\x35\x3b\x33\x37\x3b\x34\x30\x6d\x20\x1b\x5b\x31\x6d\xdc\x1b\x5b\x30\x6d\xdc\x1b\x5b\x31\x6d\x20\x1b\x5b\x30\x6d")
  sys.stdout.write(curPosition(x+1,y))
  sys.stdout.write("\x20\xdf\x1b\x5b\x31\x3b\x33\x30\x6d\xdf\x1b\x5b\x30\x6d"+clrBlack() + "\xdb")

def printWhiteStone(x,y):
  #sys.stdout.write(curPosition(x,y))
  #sys.stdout.write("\x1b\x5b\x31\x3b\x32\x35\x3b\x33\x30\x3b\x34\x30\x6d\x20\x1b\x5b\x33\x37\x6d\xdc\xdc\x20\x1b\x5b\x30\x6d")
  #sys.stdout.write(curPosition(x+1,y))
  #sys.stdout.write("\x1b\x5b\x31\x3b\x33\x30\x6d\x20\x1b\x5b\x33\x37\x6d\xdf\x1b\x5b\x30\x6d\xdf"+clrBlack()+"\xdb")
  #stoneWhite.ans
  sys.stdout.write(curPosition(x+0,y))
  sys.stdout.write("\x1b\x5b\x30\x3b\x32\x35\x3b\x33\x37\x3b\x34\x30\x6d\x20\xdc\xdc\x1b\x5b\x31\x6d\x20\x1b\x5b\x30\x6d")
  sys.stdout.write(curPosition(x+1,y))
  sys.stdout.write("\x20\xdf\x1b\x5b\x31\x3b\x33\x30\x6d\xdf\x1b\x5b\x30\x6d"+clrBlack()+"\xdb")

def printRedStone(x,y):
  #sys.stdout.write(curPosition(x,y))
  #sys.stdout.write("\x1b\x5b\x30\x3b\x32\x35\x3b\x33\x37\x3b\x34\x30\x6d\x20\x1b\x5b\x31\x3b\x33\x31\x6d\xdc\xdc\x20\x1b\x5b\x30\x6d")
  #sys.stdout.write(curPosition(x+1,y))
  #sys.stdout.write("\x20\x1b\x5b\x31\x3b\x33\x31\x6d\xdf\x1b\x5b\x30\x3b\x33\x31\x3b\x34\x30\x6d\xdf\x20\x1b\x5b\x30\x6d")
  #stoneRed.ans
  sys.stdout.write(curPosition(x+0,y))
  sys.stdout.write("\x1b\x5b\x30\x3b\x32\x35\x3b\x33\x37\x3b\x34\x30\x6d\x20\x1b\x5b\x31\x3b\x33\x31\x6d\xdc\xdc\x1b\x5b\x30\x6d"+clrBlack()+"\xdb")
  sys.stdout.write(curPosition(x+1,y))
  sys.stdout.write("\x20\x1b\x5b\x31\x3b\x33\x31\x6d\xdf\x1b\x5b\x30\x3b\x33\x31\x3b\x34\x30\x6d\xdf\x1b\x5b\x30\x6d"+clrBlack()+"\xdb")
  

def print_messages():
  for idx,val in enumerate(messages):
    if (val[1]==0):
      print_message_my(len(messages)-1-idx,val[0])
    elif (val[1]==2):
      print_message_board(len(messages)-1-idx,val[0])
    else:
      print_message_other(len(messages)-1-idx,val[0])
  print(clrWhite())

def printBoard(val):
  y=0
  x=0
  try:
    rows=val.split('\n') 
    printEmptyBoard(6,47)
    retMsg=rows[2]
    rows=rows[3:]
    #print(rows) # DEBUG
    for idx,row in enumerate(rows): # REMOVE THE FIRST LINES OF MSG
      row=(row[2:]) # SRTIP LINE NO
      for idy,ch in enumerate(row):
        if (ch=='o'):
          #sys.stdout.write(str(idy)+str(idx)+"|")
          printWhiteStone(4+2*(8-y),47+(4*idy)) # first is width
        if (ch=='x'):
          #sys.stdout.write('x: ' + str(idx)+" "+str(idy) + "|")
          printRedStone(4+2*(8-y),47+(4*idy))
        if (ch=='O'):
          #sys.stdout.write(str(idy)+str(idx)+"|")
          printWhiteKing(4+2*(8-y),47+(4*idy)) # first is width
        if (ch=='X'):
          #sys.stdout.write('x: ' + str(idx)+" "+str(idy) + "|")
          printRedKing(4+2*(8-y),47+(4*idy))
      y+=1
    return(retMsg)
  except Exception as e:
    print(e)
  
def print_message_board(idx,val):
  print(curPosition(20-idx,2)+clrBlue()+val.ljust(MAX_INPUT))

def print_message_my(idx,val):
  print(curPosition(20-idx,2)+clrWhite()+val.ljust(MAX_INPUT))

def print_message_other(idx,val):
  print(curPosition(20-idx,2)+clrRed()+val.ljust(MAX_INPUT))

def process_message(msg,source):
  if (msg=="quit"):
    try:
      s.send("--> Goodbye")
      s.close()
      sys.exit()
    except Exception as e:
      print(e)
      pass
  elif (msg.startswith("\nboard\n")):
    retMsg=printBoard(msg)
    if (retMsg!="" and retMsg != "Error" and retMsg!="..."):
      messages.append([retMsg,2])
      if (len(messages)>=CHAT_ROWS):
        messages.pop(0)
      print_messages()
  else:
    messages.append([msg,source])
    if (len(messages)>=CHAT_ROWS):
      messages.pop(0)
    print_messages()
  print(clrWhite()+curPosition(INP_Y,INP_X))
    
def printFile(filename,stripNL):
  file = open(GAME_DIR+'/'+filename)
  for line in file:
    if (stripNL==1):
      sys.stdout.write(line.replace('\x0a',''))
    else:
      sys.stdout.write(line)
 
#main function
if __name__ == "__main__":
  
  if(len(sys.argv) < 4) :
    print('Usage : python telnet.py hostname port username')
    sys.exit()
  
  host = sys.argv[1]
  port = int(sys.argv[2])
  username = sys.argv[3]
  
  HOSTNAME="127.0.0.1"
  context=ssl.create_default_context() # SSL
  
  
  sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
  sock.settimeout(2)
  s = ssl.wrap_socket(sock,certfile=GAME_DIR+'/cert.pem',keyfile=GAME_DIR+'/key.pem') # SSL
  # connect to remote host
  try :
    s.connect((host, port))
  except Exception as e:
    traceback.print_exc(file=sys.stdout)
    print(e)
    print('Unable to connect')
    sys.exit()

  s.send(("name " + username).encode('ascii'))

  tty.setraw(sys.stdin.fileno())
  print(clrReset())
  printFile('intro.ans',0) 
  print(curPosition(0,0))
  ch = sys.stdin.read(1)
  printFile('blank.ans',0) 

  ich=0
  input=""
  
  print(clrReset())
  printFile('board.ans',0) 
  print(curPosition(INP_Y,INP_X)+clrWhite())

  while 1:

    tty.setraw(sys.stdin.fileno())
    # Get the list sockets which are readable
    sockin, sockout, errsock = select.select([s], [], [],0.05)
    for sock in sockin:
      if (s==sock):
        data = sock.recv(4096)
        if not data:
          sys.exit() # DISCONNECTED FROM CHAT SERVER
        else:
          process_message(data,1)
      
    keyin, keyout, errsock = select.select([sys.stdin], [], [],0.05)
    if (keyin):
      for key in keyin:
        ch = key.read(1)
        if (ord(ch) == 8): # BACKSPACE
          if (ich>0):
            ich-=1
          print(curPosition(INP_Y+1,INP_X+ich)+" ")
          input=input[:-1]
        if (ord(ch) == 13): # ENTER
          print(curPosition(INP_Y+1,INP_X)+" "*MAX_INPUT)
          print(curPosition(INP_Y,INP_X))
          ich=0
          print(curPosition(INP_Y,INP_X+ich))
          process_message(input,0)
          if (input!=""):
            s.send(input)
          input=""
          #print('\033[2J')
          #printFile('board.ans') 
        if (ich<MAX_INPUT):
          if (ord(ch) >= 32 and ord(ch) < 127):
            print(curPosition(INP_Y+1,INP_X+ich)+ch)
            ich+=1
            input+=ch
        print(clrWhite()+curPosition(INP_Y,INP_X+ich))

