# NETWORK CHECKERS SERVER

import socket
import select
import ssl
import traceback
import os
import sys
import signal
import re

# TBD GOODBYE FROM

# CHANGE HERE
PORT = 5000
HOSTNAME="127.0.0.1"

STONE_WHITE=1
STONE_WHITE_KING=3
STONE_RED=2
STONE_RED_KING=4

CLR_GREEN="\033[31m;"
CTRL_RESET="\033[0m;"

ssock=None
DIM_X=8
DIM_Y=8

Board=[[0 for x in range(8)] for y in range(8)]

users={} 

def getSockAddr(in_sock):
  try:
    ret = int(str(sock.getpeername()[0].replace('.',''))+""+str(sock.getpeername()[1]))
  except Exception as e:
    print(e)
  return(ret)

def getUserList():
  userList=" ["
  for key,val in users.items():
    userList+=" "+str(val)+" "
  userList+="]"
  return(userList)

def processGoodbye(data,sock):
  if (data == '--> Goodbye'):
    try:
      CONNECTION_LIST.remove(sock) # This caused crashes
      del users[getSockAddr(sock)] # This caused crashes
      sock.close()
      print ("|--- CLIENT (%s, %s) DISCONNECTED" % addr)
    except Exception as e:
      print(e)
      pass

def getName(data):
  ret=0
  if ('name' in data):
    cmd=re.split('\W+',data)
    #print("len(name) " + str(len(cmd)) + " " + cmd[1] + " sock " + str(getSockAddr(sock)))
    if (len(cmd)==2):
      users[getSockAddr(sock)]=cmd[1]
      ret=1
  return(ret)

def signal_handler(sig,frame):
  print("\ro--- PROGRAM TERMINATION IN PROGRESS...")
  ssock.close()
  sys.exit(0)

def intToChar(x):
  return(str(chr(x)))

def coordToChar(x):
  return(str(chr(x+65)))

def charToCoord(x):
  ret=None
  try:  
    if (ord(x)>=65 and ord(x)<=72):
      ret = ord(x)-65
    return(ret)
  except:
    return(ret) 

def isInt(value):
  try:
    ret=int(value)
    return(ret)
  except ValueError:
    return(None)
 
def boardPutStone(x,y,val):
  Board[x][y]=val

def boardGetStone(x,y):
  return(Board[x][y])

def boardRemoveStone(x,y):
  Board[x][y]=0

def boardMoveStone(x0,y0,x1,y1):
  if Board[x0][y0]==1:
    Board[x0][y0]=0
    Board[x1][y1]=1

def convField(value):
  if (value==0):
    value='.'
  elif (value==STONE_WHITE):
    value='o'
  elif (value==STONE_RED):
    value='x'
  elif (value==STONE_WHITE_KING):
    value='O'
  elif (value==STONE_RED_KING):
    value='X'
  return(value)

def moveDualCoords(cmd):
  if (len(cmd)==5):
    cmd[1]=cmd[1]+cmd[2]
    cmd[2]=cmd[3]+cmd[4]
    cmd.pop()
    cmd.pop()
  if (len(cmd)==2):
    if (len(cmd[1])==4):
      cmd.append(cmd[1][2]+cmd[1][3])
      cmd[1]=cmd[1][:2]
  if (len(cmd)==3):
    validMove=0
    try:
      try:
        y0=9-isInt(cmd[1][1])-1 # HERE
        y1=9-isInt(cmd[2][1])-1 # HERE
      except:
        print(e)
      if (not isInt(cmd[1][0]) and not isInt(cmd[2][0])):
        x0=charToCoord(cmd[1][0].upper())
        x1=charToCoord(cmd[2][0].upper())
      else:
        x0=isInt(cmd[1][0])
        x1=isInt(cmd[2][0])
      # VALIDATE MOVE
      if (
            x0 >= 0 and x0 <= 8
        and x1 >= 0 and x1 <= 8
        and y0 >= 0 and y0 <= 8 
        and y1 >= 0 and y1 <= 8
      ):
        #print("x0 " + str(x0) + " y0 " + str(y0) 
        #    + " x1 " + str(x1) + " y1 " + str(y1))   
        #print("mx0 " + str(x0%2) + " my0 " + str(y0%2) 
        #   + " mx1 " + str(x1%2) + " my1 " + str(y1%2))
        if (x0%2!=y0%2 and x1%2!=y1%2):
          validMove=1
        stone=boardGetStone(x0,y0)
        # check for pawn movement direction
        if stone==1 and y1<y0: 
            validMove=0 
        if stone==2 and y1>y0: 
            validMove=0 
        # check if destination is empty
        dstone=boardGetStone(x1,y1)
        if dstone!=0: 
            validMove=0 
        if (validMove==1):
          boardRemoveStone(x0,y0)
          boardPutStone(x1,y1,stone)
          return(cmd[1]+cmd[2])
        else:
          return("Error")
    except Exception as e:
      traceback.print_exc(file=sys.stdout)
      pass

def stoneSingleCoords(cmd,type):
  if (len(cmd)==3):
    cmd[1]=cmd[1]+cmd[2]
    cmd.pop()
  if (len(cmd)==2):
    try:
      #print("charToCoord " + str(charToCoord(cmd[1][0].upper())))
      y=9-isInt(cmd[1][1])-1
      if isInt(cmd[1][0]): # We've coords in numbers
        boardPutStone(isInt(cmd[1][0]),y,type) 
      elif charToCoord(cmd[1][0].upper()) != None:
        boardPutStone(charToCoord(cmd[1][0].upper()),y,type) 
    except Exception as e:
      traceback.print_exc(file=sys.stdout)
      pass
 
def prepareMessage(message):

  displayBoard=0
  mirror=0
  message=message.rstrip()
  sendMsg="..."
  if (message=='reset'):
    for y in range(DIM_Y):
      for x in range(DIM_X):
        boardRemoveStone(x,y)
    displayBoard=1
    mirror=1
  elif (message=='who'):
    message=getUserList()
    #print('who')
    #print(message)
    displayBoard=0
    mirror=1
  elif (message=='credits'):
    message="By Phenom, THX: Burps, Whazzit"
    displayBoard=0
    mirror=1
  elif (message=='help'):
    message="Use: new, mv, rm"
    displayBoard=0
    mirror=1
  elif (message=='checkers'
     or message=='new'):
    try:
      for y in range(DIM_Y):
        for x in range(DIM_X):
          boardRemoveStone(x,y)
      for x in range(0,DIM_X-1,2):
        boardPutStone(x+1,0,1)
      for x in range(0,DIM_X,2):
        boardPutStone(x,1,1)
      for x in range(0,DIM_X-1,2):
        boardPutStone(x+1,2,1)
      for x in range(0,DIM_X,2):
        boardPutStone(x,5,2)
      for x in range(0,DIM_X-1,2):
        boardPutStone(x+1,6,2)
      for x in range(0,DIM_X,2):
        boardPutStone(x,7,2)
    except Exception as e:
      traceback.print_exc(file=sys.stdout)
      pass
    displayBoard=1
    mirror=1
  elif (message.lower().startswith('remove')
     or message.lower().startswith('rm')
    ):
    cmd=re.split('\W+',message)
    if (len(cmd)==3):
      cmd[1]=cmd[1]+cmd[2]
      cmd.pop()
    if (len(cmd)==2):
      try:
        y=9-isInt(cmd[1][1])-1
        if isInt(cmd[1][0]):
          boardRemoveStone(isInt(cmd[1][0]),y)
        elif (charToCoord(cmd[1][0].upper()) != None):
          boardRemoveStone(charToCoord(cmd[1][0].upper()),y)
      except Exception as e:
        traceback.print_exc(file=sys.stdout)
        pass
    displayBoard=1
    mirror=1
  elif (message.lower().startswith('move') 
    or  message.lower().startswith('m ')
    or  message.lower().startswith('mv ')
    ):
    cmd=re.split('\W+',message)
    sendMsg=moveDualCoords(cmd)
    displayBoard=1
    mirror=1
  elif (message.lower().startswith('white')):
    cmd=re.split('\W+',message)
    if (len(cmd)==2):
      stoneSingleCoords(cmd,STONE_WHITE)
    elif (len(cmd)==3):
      if cmd[1]=="king":
        cmd.pop(1)
        stoneSingleCoords(cmd,STONE_WHITE_KING)
    displayBoard=1
    mirror=1
  elif (message.lower().startswith('red')):
    cmd=re.split('\W+',message)
    if (len(cmd)==2):
      stoneSingleCoords(cmd,STONE_RED)
    elif (len(cmd)==3):
      if cmd[1]=="king":
        cmd.pop(1)
        stoneSingleCoords(cmd,STONE_RED_KING)
    displayBoard=1
    mirror=1

  if (message=="board" or displayBoard==1):
    try:
      message="\nboard\n"+sendMsg+"\n"
      for y in range(DIM_Y-1,-1,-1):
        message = message + str(y+1) + "|"
        for x in range(DIM_X):
          message = message + str(convField(Board[x][y])) + ""
        message = message + "\n"
      #print(message)
      #message=message+"  ----------------"
      message=message+"\n   "
      #for x in range(DIM_X):
      #  message = message + coordToChar(x) + " "
      mirror=1
    except Exception as e:
      traceback.print_exc(file=sys.stdout)
      print(e)
  #else:
  #  mirror=0

  return((mirror,message))

# Function to broadcast chat messages to all connected clients
def broadcast_data (sock, message,mirror):
  #Do not send the message to master socket and the client who has send us the message
  for socket in CONNECTION_LIST:
    if (socket != ssock and (mirror == 1 or socket != sock)):
      try :
        socket.send(message)
      except :
        # broken socket connection may be, chat client pressed ctrl+c for example
        socket.close()
        CONNECTION_LIST.remove(socket)

if __name__ == "__main__":

  signal.signal(signal.SIGINT, signal_handler)
  # List to keep track of socket descriptors
  CONNECTION_LIST = []
  RECV_BUFFER = 4096 # Advisable to keep it as an exponent of 2

  context=ssl.create_default_context() # SSL
  context.check_hostname = False
  #context.set_ciphers('ADH-AES256-SHA')
  #context.load_dh_params('cert.pem')

  ssock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
  # this has no effect, why ?
  ssock.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
  ssock = ssl.wrap_socket(ssock,
    keyfile="key.pem",
    certfile="cert.pem",
    server_side=True
  ) # SSL
  ssock.bind((HOSTNAME, PORT))
  ssock.listen(2)

  # Add server socket to the list of readable connections
  # print("APPEND " + str(ssock) + " TO CONNECTION LIST")
  CONNECTION_LIST.append(ssock)

  print("o--- SERVER INIT @ PORT " + str(PORT))

  while 1:
    # Get the list sockets which are ready to be read through select
    try:
      read_sockets,write_sockets,error_sockets = select.select(CONNECTION_LIST,[],[],0.25)
    except Exception as e:
      print("o--- PROGRAM SELECT PHASE ERROR") 
      ssock.close()
      sock.close()
      sys.exit(0)

    for sock in read_sockets:
      # New connection
      if sock == ssock:
      # Handle the case in which there is a new connection recieved through server_socket
        try:
          sockfd, addr = ssock.accept()
          #CONNECTION_LIST.append(sockfd)
          CONNECTION_LIST.append(sockfd)
          print ("|--- CLIENT (%s, %s) CONNECTED" % addr)
          #broadcast_data(sockfd, "|- [%s:%s] > Entered" % addr,1)
          broadcast_data(sockfd, "|_"+getUserList(),1)
        except Exception as e:
          traceback.print_exc(file=sys.stdout)
          print(e)
          continue

      # Some incoming message from a client
      else:
        # Data recieved from client, process it
        try:
          #In Windows, sometimes when a TCP program closes abruptly,
          # a "Connection reset by peer" exception will be thrown
          data=sock.recv(RECV_BUFFER)
          newName=getName(data)
          if (newName==1): #
            broadcast_data(sock, "|_ " + users[getSockAddr(sock)] + " entered...",0)
            print(users)
          elif data:
            mirror,data=prepareMessage(data)
            if (users[getSockAddr(sock)] and ('name' not in data)):
              #broadcast_data(sock, "|"+users[getSockAddr(sock)]+"| "+data,mirror)
              broadcast_data(sock, data,mirror)
            else:
              broadcast_data(sock, "|"+str(sock.getpeername()[0])+"| "+data,mirror)
          #if data:
          #  mirror,data=prepareMessage(data)
          #  broadcast_data(sock, str(sock.getpeername()[0]) + "> " + data,mirror)
          processGoodbye(data,sock)

        except:
          #broadcast_data(sock,"|_ %s  IS OFFLINE " % str(addr),0) 
          traceback.print_exc(file=sys.stdout)
          print ("|--- CLIENT (%s, %s) IS OFFLINE " % addr)
          try:
            CONNECTION_LIST.remove(sock) # This caused crashes
            del users[getSockAddr(sock)] # This caused crashes
            sock.close()
          except Exception as e:
            print(e)
            pass
          continue
  
  ssock.close()
